--- a/xbmc/cores/AudioEngine/Sinks/AESinkALSA.cpp	2020-10-25 10:03:27.000000000 +0100
+++ b/xbmc/cores/AudioEngine/Sinks/AESinkALSA.cpp       2020-10-25 10:03:27.000000000 +0100
@@ -162,7 +162,7 @@
   // According to CEA-861-D only RL and RR are known. In case of a format having SL and SR channels
   // but no BR BL channels, we use the wide map in order to open only the num of channels really
   // needed.
-  if (format.m_channelLayout.HasChannel(AE_CH_SL) && !format.m_channelLayout.HasChannel(AE_CH_BL))
+  if (format.m_channelLayout.HasChannel(AE_CH_SL) && !format.m_channelLayout.HasChannel(AE_CH_BL) && format.m_channelLayout.HasChannel(AE_CH_SR) && !format.m_channelLayout.HasChannel(AE_CH_BR))
   {
     channelMap = LegacyALSAChannelMap51Wide;
   }
@@ -387,6 +387,20 @@
       altLayout.ReplaceChannel(AE_CH_BR, AE_CH_SR);
     }
   }
+  /* asymmetrical layouts */
+  else
+  {
+    /* miniDSP USB-Streamer 10 channels (CH0 - CH9) has a back center and no side-right, fix it. set side-left and side right to CH6 and CH7, set FROC and FLOC to CH8 and CH9 (CH8 and CH9 is toslink output!) */
+    if (info.HasChannel(AE_CH_BC) && !info.HasChannel(AE_CH_SR))
+    {
+      altLayout = info;
+      altLayout.ReplaceChannel(AE_CH_BC, AE_CH_FROC);
+      altLayout.ReplaceChannel(AE_CH_SL, AE_CH_FLOC);
+      altLayout.ReplaceChannel(AE_CH_FROC, AE_CH_SR);
+      altLayout.ReplaceChannel(AE_CH_FLOC, AE_CH_SL);
+    }
+  }
+  
   return altLayout;
 }
 
